From: Hauke Mehrtens <hauke@hauke-m.de>
Date: Sun, 14 Jul 2013 13:19:58 +0000 (+0000)
Subject: brcm47xx: fix switch handling
X-Git-Url: http://git.cdn.openwrt.org/?a=commitdiff_plain;h=3bc90a4d23e05be4a54edfccae3d45eefcfa5557;p=openwrt%2Fstaging%2Fansuel.git

brcm47xx: fix switch handling

This fixes some problems with the switch handling

 * It now send the messages again to indicate a button for failsafe mode should be pressed
 * it does not leak packages between wan and lan any more
 * the switch works again in normal mode

The Ethernet connection has to be up when the switch driver switch-robo
is insmoded therefor we just do it again.
Explicitly set enable_vlan to prevent leaking packages.

This should close #13869, #13868 and #13716

SVN-Revision: 37286
---

diff --git a/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm b/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm
index ac18e0baf2..76382e5cee 100644
--- a/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm
+++ b/target/linux/brcm47xx/base-files/lib/preinit/05_init_interfaces_brcm
@@ -11,7 +11,17 @@ set_preinit_iface() {
 		"ASUS (unknown, BCM4702)") ifname=eth1;;
 		"Sitecom WL-105b") ifname=eth1;;
 	esac
+
+	# The interface has to be up to configure the switch
 	ifconfig $ifname 0.0.0.0 up
+	[ -f /lib/modules/`uname -r`/switch-robo.ko ] && {
+		rmmod switch-robo
+		insmod switch-robo
+	}
+	[ -f /lib/modules/`uname -r`/switch-adm.ko ] && {
+		rmmod switch-adm
+		insmod switch-adm
+	}
 }
 
 init_iface() {
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm b/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm
index dd8fd6e9f6..7e030acfff 100644
--- a/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm
+++ b/target/linux/brcm47xx/base-files/lib/preinit/05_set_failsafe_switch_brcm
@@ -2,13 +2,17 @@
 
 failsafe_ip() {
 	[ -d /proc/switch/eth0 ] && [ "$ifname" = "eth0" ] && {
-		ifconfig eth0 0.0.0.0 down
+		# The switch will connect all ports, The switch will leak
+		# packages from wan to lan and vice versa in failsafe mode
+		echo 1 > /proc/switch/eth0/reset
+		echo 1 > /proc/switch/eth0/enable
+		echo 0 > /proc/switch/eth0/enable_vlan
 		echo "0 1 2 3 4 ${cpu_port:-5u*}" > /proc/switch/eth0/vlan/1/ports
 	}
 
 	[ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
 		ifconfig $pi_ifname $pi_ip netmask $pi_netmask broadcast $pi_broadcast up
-        }
+	}
 }
 
 boot_hook_add failsafe failsafe_ip
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm b/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm
index 8c425a094e..bc749398f5 100644
--- a/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm
+++ b/target/linux/brcm47xx/base-files/lib/preinit/15_set_preinit_interface_brcm
@@ -1,37 +1,34 @@
 #!/bin/sh
 
-port_net_echo() {
-	[ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
-		if [ "$pi_preinit_net_messages" = "y" ] || [ "$pi_failsafe_net_message" = "true" ] && [ "$pi_preinit_no_failsafe_netmsg" != "y" ]; then
-			netmsg $pi_broadcast "$1"
-		fi
-	}
-}
-
-preinit_ip_deconfig() {
-	if [ -z "$pi_ifname" ]; then
-		ifconfig $ifname 0.0.0.0 down
-	else
-		grep -q "$pi_ifname" /proc/net/dev && {
-			ifconfig $pi_ifname 0.0.0.0 down
-		}
-	fi
-}
-
-preinit_net_echo() {
+preinit_net_echo_send() {
 	preinit_ip
 
 	[ -d /proc/switch/eth0 ] && [ "$pi_ifname" = "eth0" ] && {
+
 		echo 1 > /proc/switch/eth0/reset
+		echo 1 > /proc/switch/eth0/enable
+		echo 1 > /proc/switch/eth0/enable_vlan
 
 		# this would be easier if we blasted the message across all ports
 		# but we don't want packets leaking across interfaces
 		for port in $(seq 0 4); do {
+
 			echo "$port ${cpu_port:-5u*}" > /proc/switch/eth0/vlan/1/ports
-			port_net_echo $1
+			sleep 1
+
+			netmsg $pi_broadcast "$1"
 		}; done
 
-		echo "0 1 2 3 4 ${cpu_port:-5u*}" > /proc/switch/eth0/vlan/1/ports
+	} || netmsg $pi_broadcast "$1"
+}
 
-	} || port_net_echo $1
+preinit_net_echo() {
+	[ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
+		{ 
+			[ "$pi_preinit_net_messages" = "y" ] || {
+    		     		[ "$pi_failsafe_net_message"  = "true" ] && 
+    		         	    [ "$pi_preinit_no_failsafe_netmsg" != "y" ] 
+    		         }
+		} && preinit_net_echo_send $1
+    	}
 }
diff --git a/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm b/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm
deleted file mode 100644
index 2b0d2cccc4..0000000000
--- a/target/linux/brcm47xx/base-files/lib/preinit/20_failsafe_net_echo_brcm
+++ /dev/null
@@ -1,10 +0,0 @@
-#!/bin/sh
-
-indicate_failsafe() {
-	preinit_net_echo() {
-		port_net_echo $1
-	}
-	echo "- failsafe -"
-	preinit_net_echo "Entering Failsafe!\n"
-	indicate_failsafe_led
-}